/* -*-C-*-
   System file for Linux

$Id: linux.h,v 1.7.1.3 1998/02/13 19:40:13 cph Exp $

Copyright (c) 1995-98 Massachusetts Institute of Technology

This material was developed by the Scheme project at the Massachusetts
Institute of Technology, Department of Electrical Engineering and
Computer Science.  Permission to copy and modify this software, to
redistribute either the original software or a modified version, and
to use this software for any purpose is granted, subject to the
following restrictions and understandings.

1. Any copy made of this software must include this copyright notice
in full.

2. Users of this software agree to make their best efforts (a) to
return to the MIT Scheme project any improvements or extensions that
they make, so that these may be included in future releases; and (b)
to inform MIT of noteworthy uses of this software.

3. All materials developed as a consequence of the use of this
software shall duly acknowledge such use, in accordance with the usual
standards of acknowledging credit in academic research.

4. MIT has made no warrantee or representation that the operation of
this software will be error-free, and MIT is under no obligation to
provide any services, by way of maintenance, update, or otherwise.

5. In conjunction with products arising from the use of this material,
there shall be no use of the name of the Massachusetts Institute of
Technology nor of any adaptation thereof in any advertising,
promotional, or sales literature without prior written consent from
MIT in each case. */

#define LIBX11_SYSTEM -L/usr/X11R6/lib

#define LIB_DEBUG

#define ALTERNATE_M4 s/ultrix.m4

#define LINUX_STATIC_LIBS(libs) -Xlinker -Bstatic libs -Xlinker -Bdynamic

#ifdef __ELF__
#define M4_SWITCH_SYSTEM -P "define(LINUX_ELF,1)"
/* Newer versions of Debian don't really support termcap.  However,
   ncurses is supported on all GNU/Linux systems, so we'll use that
   instead.  */
#define LIBS_TERMCAP LINUX_STATIC_LIBS (-lncurses)
#define HAVE_TERMINFO
#define TERMCAP_FILES
#else
#define M4_SWITCH_SYSTEM
#define LIBS_TERMCAP LINUX_STATIC_LIBS (-ltermcap)
#endif

#define LD_SWITCH_SYSTEM

/* Use the built-in files <limits.h> and <float.h> rather than those
   generated by the "hard-par" program.  */
#define USE_BUILT_IN_LIMITS_FILES
